.module Main
;; Include all CPCtelera constant definitions, macros and variables
.include "cpctelera.h.s"
.include "man/globals_game.inc"
.include "sys/globals_render.inc"
.include "funciones_cpct.inc"
.include "man/globals_interrupt.inc"

;; Start of _DATA area 
.area _DATA
;; Start of _CODE area
.area _CODE

;; GLobales

.globl game_over
.globl _music_menus
.globl _music_heaven
.globl nivel
.globl man_post_level
.globl fin_del_juego

;;
;; MAIN function. This is the entry point of the application.
;;    _main:: global symbol is required for correctly compiling and linking
;;
_main::
   ;; Disable firmware to prevent it from interfering with string drawing
   call cpct_disableFirmware_asm
   cpctm_setBorder_asm HW_BLACK
   
comienza_de_nuevo:
   ld a, (nivel)
   cp #1
   jr nz, no_es_nivel_1
      ld a, (fin_del_juego)
      cp #0
      jr nz, no_es_nivel_1
      call render_completo
      call sys_render_init

      ;; inicio las interrupciones
      call man_ir_init

      ;; inicializar efectos sonoros
      ld de, #_music_menus
      call cpct_akp_SFXInit_asm

      ;; cambiar musica
      call cpct_akp_stop_asm
      ld de, #_music_menus
      call cpct_akp_musicInit_asm

      call man_game_menus
   no_es_nivel_1:
   call man_game_init
   ;; cambiar musica
   call cpct_akp_stop_asm
   ld de, #_music_heaven            ;; musica del 1er mapa que se cargue
   call cpct_akp_musicInit_asm

   call man_game_play

   ;; cambiar musica
   call cpct_akp_stop_asm
   ld de, #_music_menus
   call cpct_akp_musicInit_asm

   ld a, (fin_del_juego)
   cp #3
   jr z, post_level

      call game_over
      jr comprobar
   post_level:
      call man_post_level

   comprobar:
   call cpct_isAnyKeyPressed_asm
   jr z,reinicio;pulsada
      call cpct_scanKeyboard_asm
      jr comprobar
reinicio:
   jp comienza_de_nuevo
   ;; Loop forever
