;; This file is part of The Angel's Choice.

;; The Angel's Choice is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

;; The Angel's Choice is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License along with Foobar. If not, see https://www.gnu.org/licenses/.

.module Game
;; Start of _CODE area
.area _CODE

.include "man/datos_entity.inc"
.include "man/globals_ent.inc"
.include "sys/globals_render.inc"
.include "sys/globals_phy.inc"
.include "sys/globals_ia.inc"
.include "sys/globals_generator.inc"
.include "sys/globals_collision.inc"
.include "sys/globals_animation.inc"
.include "sys/globals_hud.inc"
.include "sys/globals_camera.inc" ;; camara
.include "man/templates.inc"
.include "man/globals_maps.inc"
.include "assets/assets.inc"
.include "menus/menu.inc"
.include "funciones_cpct.inc"




cant_crear:
    .db #90

fin_del_juego::
    .db #0
nivel::
    .db #1

.globl prueba


man_generate_entity:
    push hl
    call man_create_entity
    ;(2B DE) to	Pointer to the destination (first byte where bytes will be written)
    ;(2B HL) from	Pointer to the source (first byte from which bytes will be read)
    ;(2B BC) size	Number of bytes to be set (>= 1)
    ld d,h
    ld e,l
    pop hl
    ld bc,#tam_ent
    push de
    call cpct_memcpy_asm
    pop ix
    ret




man_game_init::
    ld a, #90
    ld (cant_crear),a
    call man_entity_init
    call man_mapa_init
    call sys_render_init_level
    ld hl,#principal
    call man_generate_entity
    
    ld hl,#puerta
    call man_generate_entity

    ld hl,#carta
    call man_generate_entity

    call sys_init_hud
    call sys_generate_init
    

    ret

man_game_menus::

    menu_begin_1:
   call menu_begin
   ld a, (selected)
   cp #1
   jr z, vamos_a_jugar
      call game_opt
      comprobar:
      call cpct_isAnyKeyPressed_asm
      jr z,next;pulsada
      call cpct_scanKeyboard_asm
      jr comprobar
   next:
   ld a, #2
   ld (selected),a
   ld a, #0
   ld (selected+1),a
      jr menu_begin_1
vamos_a_jugar:
ret


man_game_play::
    call sys_render_UI_2
    ld a, #0
    ld (fin_del_juego),a
    loop:
    ld a,(prueba)
    add #1
    ld (prueba),a
    call sys_render_update 
    call sys_generator_update
    call sys_ia_update
    call sys_physics_update  
    call sys_animation_update
    call sys_collision_update_mapa
    call sys_collision_update_enemigos
    call sys_collision_update_objetos
    call sys_collision_update_obstaculos
    call man_entity_update
    call sys_camera_update                  ;; posicion de la camara
    call man_mapa_change
    call sys_eliminados_update
    call cpct_waitVSYNC_asm   

    call cpct_scanKeyboard_asm
    ld a, (fin_del_juego)
    cp #0
    jr z, loop
    cp #3
    
    call change_screen_to_C000
    ld a, (puntuacion)
    ld (puntos_finales),a  
    ld a, (puntuacion+1)
    ld (puntos_finales+1),a  
    ret




