;; This file is part of The Angel's Choice.

;; The Angel's Choice is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

;; The Angel's Choice is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License along with Foobar. If not, see https://www.gnu.org/licenses/.

.include "cpctelera.h.s"
.include "man/globals_interrupt.inc"

.globl cpct_waitVSYNC_asm

man_it_current_interrupt:: .db 6

man_ir_init::
   im 1  ;; modo 1 de interrupciones
   call cpct_waitVSYNC_asm
   halt
   halt  ;; Aqui VSYNC habrá terminado
   call cpct_waitVSYNC_asm
   di    ;; deshabilito interrupciones

   ;; poner JP en 0x38
   ld a, #0xC3 ;; JP == 0xC3
   ld (0x38), a
   ;; Direccion de salto
   ld hl, #man_ir_1
   ld (0x39), hl

   ei    ;; habilito interrupciones
   ret

man_ir_1::
   cpctm_push af, bc, hl

   setNumIR 1
   setNextManIR man_ir_2
   ;cpctm_setBorder_asm HW_BLACK

   cpctm_pop hl, bc, af
   ei
   reti

man_ir_2::
   cpctm_push af, bc, hl

   setNumIR 2
   setNextManIR man_ir_3
   ;cpctm_setBorder_asm HW_GREEN

   cpctm_pop hl, bc, af
   ei
   reti

man_ir_3::
   cpctm_push af, bc, hl

   setNumIR 3
   setNextManIR man_ir_4
   ;cpctm_setBorder_asm HW_RED

   cpctm_pop hl, bc, af
   ei
   reti

man_ir_4::
   cpctm_push af, bc, de, hl
   exx
   ex af, af'
   cpctm_push af, bc, de, hl

   setNumIR 4
   setNextManIR man_ir_5

   ;cpctm_setBorder_asm HW_BRIGHT_RED
   call cpct_akp_musicPlay_asm
   ;cpctm_setBorder_asm HW_YELLOW

   cpctm_pop hl, de, bc, af
   exx
   ex af, af'
   cpctm_pop hl, de, bc, af

   ei
   reti

man_ir_5::
   cpctm_push af, bc, hl

   setNumIR 5
   setNextManIR man_ir_6

   cpctm_setBorder_asm HW_BLACK         

   cpctm_pop hl, bc, af
   ei
   reti

man_ir_6::
   cpctm_push af, bc, hl

   setNumIR 6
   setNextManIR man_ir_1

   cpctm_pop hl, bc, af
   ei
   reti

