;; This file is part of The Angel's Choice.

;; The Angel's Choice is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

;; The Angel's Choice is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License along with Foobar. If not, see https://www.gnu.org/licenses/.

.module Mapa

.include "cpctelera.h.s"
.include "man/datos_maps.inc"
.include "assets/assets.inc"
.include "man/datos_entity.inc"
.include "funciones_cpct.inc"
.include "sys/globals_hud.inc"
.include "sys/globals_render.inc"
.include "sys/globals_generator.inc"
.include "man/globals_ent.inc"


.area _CODE


.globl _music_heaven
.globl _music_hell
.globl nivel

mapas_general:
    .dw _infierno, _cielo, _infierno_2, _cielo_2, _infierno_3, _cielo_3

mapas::
    .dw _infierno, _cielo

actual::
    .dw mapas

cambio::
    .db 0, 0 ;;el primero toca cambiar, el segundo indica a donde vamos (si vale 1 estamos en el cielo, si vale 0 infierno)

MAPA = 1

NIVEL_1 = 0
NIVEL_2 = 4
NIVEL_3 = 8

man_mapa_init::
    ;;ELEGIR MAPA DE NIVEL
    ld a, (nivel)
    cp #1
    jr nz, no_estamos_en_nivel_1
        ld hl, #(mapas_general + NIVEL_1)
        jp continua
    no_estamos_en_nivel_1:
    cp #2
    jr nz, no_estamos_en_nivel_2
        ld hl, #(mapas_general + NIVEL_2)
        jp continua
    no_estamos_en_nivel_2:
    cp #3
    jr nz, no_estamos_en_nivel_3
        ld hl, #(mapas_general + NIVEL_3)
        jp continua
    no_estamos_en_nivel_3:
    cp #4
    jr nz, no_estamos_en_nivel_4
        ld hl, #(mapas_general + NIVEL_1)
        jp continua
    no_estamos_en_nivel_4:
        ld hl, #(mapas_general + NIVEL_2)
        jp continua

    continua:
     ld a, (hl)
    ld (mapas), a
    inc hl
    ld a, (hl)
    ld (mapas+1), a
    inc hl
    ld a, (hl)
    ld (mapas+2), a
    inc hl
    ld a, (hl)
    ld (mapas+3), a
    ;;;COLOCAR EL CIELO
    ld hl, #mapas ;cargamos la variable que tiene el puntero a los mapas
    inc hl
    inc hl ;vamos a la posicion del cielo (+2)
    ld (actual), hl ;la cargamos en actual
    ld a, #0
    ld (cambio), a ;ponemos cambiar a 0
    ld a, #1
    ld (cambio + MAPA), a ; y el mapa actual a cielo
ret

;;;recibe en DE hacia donde se mueve
man_mapa_change::
    ld a, (cambio)
    cp #0
    ret z
    ld a, (cambio + MAPA)
    cp #1
    jr z, estamos_en_el_cielo
            ld de, #MAP_INF
            call sys_hud_change_to_hell
            ld hl, #entities
            ld c, #tam_ent
            ld b, #0
            add hl, bc
            push hl
            pop ix
            ld e_sprite_h(ix), #>_puerta_0
            ld e_sprite_l(ix), #<_puerta_0
            cpctm_push af, bc, de, hl
            ld a, #2
            call man_get_from_idx
            ld e_type(ix), #0x66
            cpctm_pop hl, de, bc, af
             ;; cambiar musica
            push de
            call cpct_akp_stop_asm
            ld de, #_music_hell
            call cpct_akp_musicInit_asm
            pop de

        jr calcular
    estamos_en_el_cielo:
        ld de, #MAP_CIE
        call sys_hud_change_to_heaven
        ld hl, #entities
            ld c, #tam_ent
            ld b, #0
            add hl, bc
            push hl
            pop ix
            ld e_sprite_h(ix), #>_puerta_1
            ld e_sprite_l(ix), #<_puerta_1

             cpctm_push af, bc, de, hl
            ld a, #2
            call man_get_from_idx
            ld e_type(ix), #0x67
            cpctm_pop hl, de, bc, af
        ;; cambiar musica
        push de
        call cpct_akp_stop_asm
        ld de, #_music_heaven
        call cpct_akp_musicInit_asm
        pop de

    calcular:
    ld hl, (actual)
    add hl,de
    ld (actual),hl
    ld a, #0
    ld (cambio),a
    call sys_render_UI_2
ret

man_get_current_map::
    ld hl, (actual)
    ld e, (hl)
    inc hl
    ld d, (hl)
ret

map_set_change::
    ld a, #1
    ld (cambio),a
    ld a, (cambio + MAPA)
    cp #1
    jr z, nos_vamos_al_infierno
        ld a, #1
        ld (cambio + MAPA),a
        ret
    nos_vamos_al_infierno:
    ld a, #0
    ld (cambio + MAPA),a
    ret