;; This file is part of The Angel's Choice.

;; The Angel's Choice is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

;; The Angel's Choice is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License along with Foobar. If not, see https://www.gnu.org/licenses/.

.include "cpctelera.h.s"
.include "assets/assets.inc"
.include "menus/datos_menu.inc"
.include "sys/globals_render.inc"
.include "funciones_cpct.inc"

.area _CODE

;; Define one Zero-terminated string to be used later on

.globl detalles_puntuacion
.globl puntuacion
.globl render_frase
.globl selected
.globl pos_title
.globl fin_del_juego
.globl nivel

game_over_opt: .asciz "GAME OVER";
game_over_win: .asciz "YOU WIN"

op_return: .asciz "BACK TO MENU"
op_try_again:  .asciz "TRY AGAIN"

puntos_finales:: .db #0, #0, #0x30, #0
puntos: .asciz "SCORE:"

arrow_elegido:
    .db #13, #160, #4, #8, #>_flecha_2, #<_flecha_2, #0x0D
; x,y,width, height,sprite_h, sprite_l, color del texto


arrow_puntos:
    .db #8, #110, #4, #8,#0,#0, #1
; x,y,width, height,sprite_h, sprite_l, color del texto

update_enter:
   call cpct_isAnyKeyPressed_asm
   or a
   jr z, fin_loop
      ld hl,#Key_Space; si pulsamos enter elegimos una
      call cpct_isKeyPressed_asm
      jr z, fin_loop
         call elegir_enter
   fin_loop:
   ret

draw_render:
   call draw_over
   call draw_puntos
   call draw_opcion
ret




game_over::
   
   call cpct_isAnyKeyPressed_asm
   jr z,next;pulsada
      call cpct_scanKeyboard_asm
      jr game_over

next:
   ld a, #1
   ld (selected),a
   ld a, #0
   ld (selected+1),a
   call render_fondo_menu
game_opt_1:
   call draw_render
   call update_enter
    call cpct_waitVSYNC_asm
    call cpct_waitVSYNC_asm
    call cpct_scanKeyboard_asm
    ld a, (selected+1)
    cp #1
    jr z, borrar_menu
      jp game_opt_1
borrar_menu:
   ld a,(fin_del_juego)
   cp #2
   jr nz, no_nivel_1
      ld a, #0
      ld (fin_del_juego),a
      ld a, #1
      ld (nivel),a
   no_nivel_1:
    ld a, #0
   ld (selected+1),a
ret

draw_over:

;;TEXTO OVER
   ld a,(fin_del_juego)
   cp #1
   jr z, pongo_game_over   
      ld iy, #game_over_win
      jr color
   pongo_game_over:
   ld iy, #game_over_opt
   color:;/
   ld ix, #pos_title  ;| Se dibuja click to en la linea indicada para arrow left
   ld b, #12
    ld h, #0X0B
   call dibujar_frase   ;\
ret
draw_opcion:
   ld a,(fin_del_juego)
   cp #1
   jr z, pongo_back   
      ld iy, #op_return
      jr color_seguir
   pongo_back:
   ld iy, #op_try_again
   color_seguir:;/
   ld ix, #arrow_elegido
   call dibujar_sprite
   ld b, #5
    ld h, #0X0B
   call dibujar_frase
ret

draw_puntos:
   ld iy, #puntos;/
   ld ix, #arrow_puntos ;| Se dibuja click to en la linea indicada para arrow left
   ld b, #15
    ld h, #0X0B
   call dibujar_frase   ;\
   ld iy, #puntos_finales;/
   ld ix, #arrow_puntos
   ld b, #38
    ld h, #0X0B
   call dibujar_frase

   ;ld ix, #detalles_puntuacion 
   ; ld iy, #puntuacion
   ; call render_frase ;le pasamos en iy lo que tiene que escribir
ret

elegir_enter:
    ld a, #1
    ld (selected+1),a
ret
