;; This file is part of The Angel's Choice.

;; The Angel's Choice is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

;; The Angel's Choice is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License along with Foobar. If not, see https://www.gnu.org/licenses/.

.include "cpctelera.h.s"
.include "assets/assets.inc"
.include "menus/datos_menu.inc"
.include "sys/globals_render.inc"
.include "funciones_cpct.inc"

.area _CODE

;; Define one Zero-terminated string to be used later on

.globl pos_title
.globl selected
title_opt: .asciz "OPTIONS"
op_left: .asciz "Pres to ";
op_left_2: .asciz "Move Left"
op_right: .asciz "Press to";
op_right_2: .asciz "Move Right"
op_up: .asciz "Press";
op_up_2: .asciz "to Jump"
op_return: .asciz "RETURN"

arrow_elegido:
    .db #20, #160, #4, #8, #>_flecha_2, #<_flecha_2, #0x0D
; x,y,width, height,sprite_h, sprite_l, color del texto

arrow_left:
    .db #8, #60, #20, #19, #>_teclas_0, #<_teclas_0, #1
; x,y,width, height,sprite_h, sprite_l, color del texto
arrow_right:
    .db #8, #90, #20, #19, #>_teclas_1, #<_teclas_1, #1
; x,y,width, height,sprite_h, sprite_l, color del texto
arrow_up:
    .db #8, #120, #20, #19, #>_teclas_2, #<_teclas_2, #1
; x,y,width, height,sprite_h, sprite_l, color del texto

update_enter:
   call cpct_isAnyKeyPressed_asm
   or a
   jr z, fin_loop
      ld hl,#Key_Space; si pulsamos enter elegimos una
      call cpct_isKeyPressed_asm
      jr z, fin_loop
         call elegir_enter
   fin_loop:
   ret

draw_render:
   ld iy, #title_opt
    ld ix, #pos_title
    ld b, #0
    ld h, #0X0B
    call dibujar_frase
   call draw_flechas
   call draw_opcion
ret




game_opt::
   call render_fondo_menu
   ld ix, #pos_title
    ld m_y(ix), #30
    ld m_x(ix), #20
bucl_opciones:
   call cpct_isAnyKeyPressed_asm
   jr z,next;pulsada
      call cpct_scanKeyboard_asm
      jr bucl_opciones
next:
   ld a, #1
   ld (selected),a
   ld a, #0
   ld (selected+1),a
game_opt_1:
   call update_enter
   call draw_render
    call cpct_waitVSYNC_asm
    call cpct_waitVSYNC_asm
    call cpct_scanKeyboard_asm
    ld a, (selected+1)
    cp #1
    jr z, borrar_menu
      jp game_opt_1

borrar_menu:
    call render_completo
ret

draw_flechas:

;;FLECHA IZQUIERDA
   ld iy, #op_left      ;/
   ld ix, #arrow_left   ;| Se dibuja click to en la linea indicada para arrow left
   call dibujar_sprite 
   ld b, #20 ;|
   ld h, #0X0B
   call dibujar_frase   ;\
   ld ix, #arrow_left   
   ld a, m_y(ix)   ;se baja a la linea de abajo (cada letra son 8 espacios)
   add #9
   ld m_y(ix),a
   ld iy, #op_left_2   ; se coge move left
   ld b, #20
    ld h, #0X0B
   call dibujar_frase
   ld ix, #arrow_left ; se devuelve a la posicion de la primera linea
   ld a, m_y(ix)
   sub #9
   ld m_y(ix),a

;; FLECHA DERECHA
   ld iy, #op_right
   ld ix, #arrow_right
   call dibujar_sprite
   ld b, #20
    ld h, #0X0B
   call dibujar_frase
   ld ix, #arrow_right
   ld a, m_y(ix)
   add #9
   ld m_y(ix),a
   ld iy, #op_right_2
   ld b, #20
    ld h, #0X0B
   call dibujar_frase
   ld ix, #arrow_right
   ld a, m_y(ix)
   sub #9
   ld m_y(ix),a

;;FLECHA UP
   ld iy, #op_up
   ld ix, #arrow_up
   call dibujar_sprite
   ld b, #20
    ld h, #0X0B
   call dibujar_frase
   ld ix, #arrow_up
   ld a, m_y(ix)
   add #9
   ld m_y(ix),a
   ld iy, #op_up_2
   ld b, #20
    ld h, #0X0B
   call dibujar_frase
   ld ix, #arrow_up
   ld a, m_y(ix)
   sub #9
   ld m_y(ix),a

ret
draw_opcion:
   ld iy, #op_return
   ld ix, #arrow_elegido
   call dibujar_sprite
   ld b, #5
    ld h, #0X0B
   call dibujar_frase
ret


elegir_enter:
    ld a, #1
    ld (selected+1),a
ret
