;; This file is part of The Angel's Choice.

;; The Angel's Choice is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

;; The Angel's Choice is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License along with Foobar. If not, see https://www.gnu.org/licenses/.

.module Animation


.include "man/datos_entity.inc"
.include "sys/animaciones_angel.inc"
.include "sys/animaciones_demo.inc"
.include "man/globals_ent.inc"
.include "funciones_cpct.inc"

.area _CODE


sys_animation_update::
    ld hl,#sys_animation_update_one 
    ld a,#e_type_animar
    call man_entity_for_all_matching
ret


sys_animation_update_one::
    ld a, debo_animar(ix)
    cp #0
    jp z, no_toca_animar
    ld e, animacion_l(ix)
    ld d, animacion_h(ix) ; DE APUNTA A UNA POSICION DE NAVE_CAMBIANDO_COLOR
    ex de,hl
    continua_Anim:
    ld c,(hl) 
    inc hl
    ld b,(hl)
    inc hl

    ld a, c
    or b
    jr z, noMoreAnim


    ld animacion_h(ix),h
    ld animacion_l(ix),l

    ;ld hl,#_nave1_1
    ld e_sprite_h(ix), b
    ld e_sprite_l(ix),c
    ld debo_animar(ix),#1
    no_toca_animar:
ret
    noMoreAnim:
        ld a, (hl) ;cuando llega al cero incrementa para volver al comienzo
        inc hl
        ld h,(hl)
        ld l, a
        jp continua_Anim
ret

sys_update_direccion_anim::
    ld b, a ;cargamos el parametro en b
    ld a, direccion_actual(ix) ; recogemos la posicion actual
    cp b ; a-b = direccion actual menos el parametro
    jr z, no_toca_cambiar ; si es 0 es la misma direccion, no hacemos nada
        ld a,b ;sino toca cambiar por lo que cargamos la direccion en a
        cp #1
        jr z, cambiamos_a_up
            cp #2
            jr z, cambiamos_a_derecha
            cp #3
            jr z, cambiamos_a_izquierda
                ld l,#<angel_esperando
                ld h, #>angel_esperando
                ld animacion_h(ix),h
                ld animacion_l(ix),l
                ld direccion_actual(ix),#0
                jp no_toca_cambiar
            
        cambiamos_a_izquierda:
            ld l,#<angel_izquierda
            ld h, #>angel_izquierda
            ld animacion_h(ix),h
            ld animacion_l(ix),l
            ld direccion_actual(ix),#3
            jp no_toca_cambiar

        cambiamos_a_derecha:
            ld l,#<angel_derecha
            ld h, #>angel_derecha
            ld animacion_h(ix),h
            ld animacion_l(ix),l
            ld direccion_actual(ix),#2
            jp no_toca_cambiar
        cambiamos_a_up:
            ld l,#<angel_saltando
            ld h, #>angel_saltando
            ld animacion_h(ix),h
            ld animacion_l(ix),l
            ld direccion_actual(ix),#1
    no_toca_cambiar:
ret

sys_update_direccion_demonios::
    ld b, a ;cargamos el parametro en b
    ld a, direccion_actual(ix) ; recogemos la posicion actual
    cp b ; a-b = direccion actual menos el parametro
    jr z, no_toca_cambiar_demo ; si es 0 es la misma direccion, no hacemos nada
        ld a,b ;sino toca cambiar por lo que cargamos la direccion en a
        cp #0
        jr z, cambiamos_a_derecha_demo
                ld l,#<demo_izquierda
                ld h, #>demo_izquierda
                ld animacion_h(ix),h
                ld animacion_l(ix),l
                ld direccion_actual(ix),#1
                jp no_toca_cambiar_demo

        cambiamos_a_derecha_demo:
            ld l,#<demo_derecha
            ld h, #>demo_derecha
            ld animacion_h(ix),h
            ld animacion_l(ix),l
            ld direccion_actual(ix),#0
            jp no_toca_cambiar_demo
    no_toca_cambiar_demo:
ret