;; This file is part of The Angel's Choice.

;; The Angel's Choice is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

;; The Angel's Choice is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License along with Foobar. If not, see https://www.gnu.org/licenses/.

.module collision

.include "cpctelera.h.s"
.include "man/datos_entity.inc"
.include "man/globals_ent.inc"
.include "assets/assets.inc"
.include "sys/globals_hud.inc"
.include "sys/globals_animation.inc"
.include "man/globals_maps.inc"
.include "funciones_cpct.inc"
.globl _back_buffer
.globl nivel

v_h = 0
v_l = 1


.area _CODE

;; variables
v_ancho_o_alto: .db #0 ;; ancho_o_alto
v_colision: .db #0 ;; colision

sys_collision_update_enemigos::
    ld hl, #comprueba_colision 
    ld a, #e_type_ia
    call man_entity_for_all_matching
ret


;;COLISION CON ENEMIGOS;;;
comprueba_colision::
    ld iy, #entities ;; carga el jugador

;; COMPRUEBO X
    ld c, e_x(ix) ;; posX-enemigo 
    ld d, e_width(ix) ;; ancho-enemigo
    ld hl, #v_ancho_o_alto ;; comprueba ancho(X)
    ld (hl), #0

    call bucle_colisiones

    ;; hay colision en X?
    ld hl, #v_colision
    ld a, (hl)
    cp #0
    jr z, no_col
        ;; ha habido colision -> compruebo colisiones en alto(Y)
 ;; COMPRUEBO Y
        ld c, e_y(ix) ;; posY-enemigo 
        ld d, e_height(ix) ;; alto-enemigo

        ld hl, #v_ancho_o_alto ;; comprueba ancho(X)
        ld (hl), #1 ;; comprueba alto(Y)

        call bucle_colisiones

        ;; hay colision en Y?
        ld hl, #v_colision
        ld a, (hl)
        cp #0
        jr z, no_col
            ;; HA HABIDO COLISION
            ld a, e_type(ix)
            and #e_type_objeto
            jr z,no_es_objeto
                call hay_colision_obj
                ret
            no_es_objeto:
                call hay_colision
            ret
    no_col: ;; nave sin colision
        ld a, e_type(ix)
        and #e_type_objeto
        jr z,no_es_objeto_ni_col
        ld e_prev_col(ix), #0
            ret
        no_es_objeto_ni_col:
        ld a, e_ia_type(ix)
        cp #1
        jr z, estoy_en_type_1_2
            ld e_prev_col(ix), #0
            ld e_width(ix), #0x03
            ld e_height(ix), #0x0c
            ret
        estoy_en_type_1_2:
            ld e_width(ix), #0x04
            ld e_height(ix), #0x0a
            ld e_prev_col(ix), #0
        ret

bucle_colisiones:
    ;; bucle para recorrer los px de X/Y del enemigo
    bucle_enemigo:
        ld hl, #v_ancho_o_alto
        ld a, (hl)
        cp #0
        jr nz, alto
            ;; si tengo que comparar el ancho
            ld b, e_x(iy) ;; posX-jugador 
            ld e, e_width(iy) ;; ancho-jugador
            jr bucle_jugador
        alto:
            ;; si es el alto
            ld b, e_y(iy) ;; posY-jugador 
            ld e, e_height(iy) ;; alto-jugador
        bucle_jugador:
            ;; comparo posX/Y-enemigo con posX/Y-jugador 
            ld a, c
            cp b    
            jr z, col ;; coinciden
                ;; no coinciden -> posX/Y-jugador++ y ancho/alto-jugador-- (siguiente px del jugador)
                inc b
                dec e
                ;; comparo el siguiente px para saber si es 0 (acabaria el sprite) JUGADOR
                ld a, e
                or a
                ;; si no ha acabado el sprite (nz) -> sigo comprobando pixeles del jugador (bucle_jugador)
        jr nz, bucle_jugador
            ;; posX/Y-enemigo++ y ancho/alto-enemigo-- 
            inc c
            dec d
            ;; comparo el siguiente px para saber si es 0 (acabaria el sprite) ENEMIGO
            ld a, d
            or a
            ;; si no ha acabado -> vuelvo a empezar el bucle -> para comprobar de nuevo todas las X/Y de jugador con el px actual de enemigo
    jr nz, bucle_enemigo
    ld hl, #v_colision ;; comprueba ancho(X)
    ld (hl), #0 ;; no ha habido colision
    ret
    col:
        ld hl, #v_colision ;; comprueba ancho(X)
        ld (hl), #1 ;; ha habido colision
        ret 

hay_colision:
    ld a, e_y(ix) ;; posY-enemigo
    ;sub #0x02 ;; 12/2 = alto-enemigo/2
    ld d, a
    ld a, e_y(iy)  ;; posY-jugador
    ;add #0x08  ;; 16/2 = alto-jugador/2
    cp d ;; jugador - enemigo
    jr nc, positivo 
        ld a, salto(iy)
        cp #0
        jp z, positivo
        ;;negativo -> esta encima -> colision superior
        ld a, e_ia_type(ix)
        cp #1
        jr z, estoy_en_type_1
            ld e_width(ix), #0x03
            ld e_height(ix), #0x0c
            ld e_sprite_h(ix), #>_demonio_pa
            ld e_sprite_l(ix), #<_demonio_pa
        jr sigo_2
        estoy_en_type_1:
            ld e_width(ix), #0x07
            ld e_height(ix), #0x0c
            ld e_sprite_h(ix), #>_demonio
            ld e_sprite_l(ix), #<_demonio
            
        sigo_2:
        
        ld a,e_prev_col(ix)
        cp #1
        jr z, salgo
            ld e_prev_col(ix),#1
            ld a, e_cont_colisiones(ix)
            sub #1
            cp #0
            jr nz, no_end_enemy
            push ix
            call sys_update_puntuacion
            pop ix
            call man_set_4_destroy
            ret
            no_end_enemy:
                ld animacion_h(ix), #>demo_estatico
                ld animacion_l(ix), #<demo_estatico
                ld a, #1
                ld e_cont_colisiones(ix),a
            ret
        salgo:
        ;pop ix
        ret

    positivo: ;; esta por otro lado -> colision normal
        
        ld a, e_ia_type(ix)
        cp #0
        jr z, estoy_en_type_0
            ld e_width(ix), #0x07
            ld e_height(ix), #0x0c
            ld e_sprite_h(ix), #>_demonio
            ld e_sprite_l(ix), #<_demonio
        jr sigo
        estoy_en_type_0:
            ld e_width(ix), #0x03
            ld e_height(ix), #0x0c
            ld e_sprite_h(ix), #>_demonio_pa
            ld e_sprite_l(ix), #<_demonio_pa
        sigo:
        ;ld e_prev_col(ix), #0
        push ix
        ld a,e_prev_col(ix)
        cp #1
        jr z, salgo_lado
            ld e_prev_col(ix),#1
            call sys_update_corazones
            pop ix
            ret
        salgo_lado:
        pop ix
        ret


;;COLISIONES CON OBJETOS;;;

;; *****************************************************************************************************************************

;; -----------------------------------------------------------------------------------------------------------------------------
;; COLLISION UPDATE
;; -----------------------------------------------------------------------------------------------------------------------------


sys_collision_update_objetos::
    ld hl, #comprueba_colision
    ld a, #e_type_objeto
    call man_entity_for_all_matching
ret

hay_colision_obj:
    ld a,e_type(ix)
    and #e_type_render
    ret z
    push ix
    ld a,e_prev_col(ix)
    cp #1
    jr z, salgo_obj
    ld e_prev_col(ix),#1
    pop ix
    ld a, e_type(ix)
    and #e_type_ia_libre
    jr z,no_es_carta
        push ix
        call sys_add_corazon
        pop ix
        ld e_type(ix), #0x66

        ret
    no_es_carta:
    call map_set_change
    ret
    salgo_obj:
    pop ix
    ret



;; *****************************************************************************************************************************
;; COLISIONES CON EL MAPA
;; *****************************************************************************************************************************

;; -----------------------------------------------------------------------------------------------------------------------------
;; COLLISION UPDATE MAPA
;; -> Recorre todas las entidades y llama al metodo de calcular la direccion del tile
;; -----------------------------------------------------------------------------------------------------------------------------

sys_collision_update_mapa::

   ;;xor   a                                  ;; Pongo el registro a en 0 
   ld    hl, #calculate_address_iy_intermedio ;; Calcular la direccion de memoria del tile donde esta mi personaje -> me lo devuelve en iy
   call man_entity_for_all                    ;; Recorro todas las entidades
   
ret

;; -----------------------------------------------------------------------------------------------------------------------------
;; COLLISION UPDATE OBSTACULOS
;; -> Llama a el metodo de calcular la direccion del tile para las colisiones con obstaculos
;; -----------------------------------------------------------------------------------------------------------------------------

sys_collision_update_obstaculos::

    ld a, #(8-1)                              ;; Le paso por parametro el punto donde va a calcular el tile
    ld d,a
    xor a
    call man_get_from_idx                     ;; Cojo la entidad jugador, en este caso la primera
    call calculate_address_iy                 ;; Calculo el tile  
    call collision_obstaculos                 ;; Compruebo las colisiones
ret

;; -----------------------------------------------------------------------------------------------------------------------------
;; COLLISION PLAYER CON LAS PLATAFORMAS
;; -> Comprueba las colisiones del jugador y lo recoloca en la posicion
;; -----------------------------------------------------------------------------------------------------------------------------

collision_player:
    ld a,#08                                
    cp (iy) 
    jr c, no_colisiona_izq_player           ;; Compruebo si colisiona la esquina inferior izquierda

        ;;ld    hl, (#_back_buffer)           ;; Cuando hay colision
        ;;ld    (hl), #0xF0
        ld a, e_y(ix)                       ;; Pongo el salto en la misma posicion
        ld e_prev_salto(ix),a               ;; Cuando colisiona pone e_prev_salto a la posicion actual

        ; ld e_y_screen(ix),a
        ; add #8
        ; ld a, e_y_screen(ix)
  
        ret

        no_colisiona_izq_player:            ;; Si no colisiona por la izquierda comprobar la esquina inferior derecha
        push iy
        pop hl
        inc hl                              ;; Compruebo el siguiente tile para la esquina inferior derecha
        ld a,#08
        cp(hl)
        jr c, no_colisiona_der_player       ;; Colisiona por la derecha
   
            ;;ld    hl, (#_back_buffer)
            ;;ld    (hl), #0xFF
            ld a, e_y(ix)
            ld e_prev_salto(ix),a
            ret

        no_colisiona_der_player:                ;; NO COLISIONA POR NINGÚN LADO
            
                ;ld salto(ix),#1                ;;CUANDO NO COLISIONA ACTIVA EL SALTO Y GUARDA E_PREV_SALTO LO MÁS BAJO POSIBLE
                ;ld e_vy(ix), #1
                ld a,e_pos_salto(ix)            ;;ya estoy saltando?
                cp #0
                jr z, inicio_salto
                ret
                inicio_salto:                   ;;si comienzo el salto, guardo en la e_prev_salto, la y para la condicion
                    ld a, #1
                    ld e_pos_salto(ix),a
                    ld a, #0xf0
                    ld e_prev_salto(ix), a
                    ld e_vy(ix),#1
                    ld salto(ix), #1

ret

;; -----------------------------------------------------------------------------------------------------------------------------
;; COLLISION OBSTACULOS
;; -> Comprueba las colisiones con los obstaculos
;; -> TILES OBSTACULOS: 9,10,11
;; -----------------------------------------------------------------------------------------------------------------------------
collision_obstaculos:
    ld a,#16
    cp (iy)                                   ;; Comprobar que sea menor que 11 para saber si es colisionables            
    jr c, no_obstaculo_izq                       
        ld a,#08
        cp (iy)                               ;; Comprobar que sea mayor que 9 para saber si es un obstaculo 
        jr nc, no_obstaculo_izq
            
            ld a, e_x(ix)
            add #5
            ld e_x(ix),a

            push ix
            call sys_update_corazones           ;; Restar vidas si colisiona
            pop ix
            ret 

        no_obstaculo_izq:
            push iy
            pop hl
            inc hl                           ;; Compruebo el siguiente tile para la esquina inferior derecha
            ld a,#16
            cp(hl)
            jr c, no_colisionable_2
            ld a,#08
            cp(hl)
            jr nc, no_obstaculo_der
            ld a, e_x(ix)
            add #-5
            ld e_x(ix),a

            push ix
            call sys_update_corazones           ;; Restar vidas si colisiona
            pop ix
            ret
            no_obstaculo_der:
            no_colisionable_2:

          
    
    
ret

;; -----------------------------------------------------------------------------------------------------------------------------
;; COLLISION ENEMY
;; -> Comprueba las colisiones del enemigo y cambia de direccion
;; -----------------------------------------------------------------------------------------------------------------------------
collision_enemy:

    ld a,#08 
    cp (iy) 
    jr c, no_colisiona_izq_enemy            ;; Compruebo si colisiona la esquina inferior izquierda
        push iy                             ;; Compruebo si hay colision por la derecha
        pop hl
        inc hl                              ;; Compruebo el siguiente tile para la esquina inferior derecha
        ;;ld bc #20
        ;;add hl,bc
        ld a,#08 
        cp(hl)
        jr c, no_colisiona_der_enemy_1
            ret                             ;; Si hay colision no pasa nada
            no_colisiona_der_enemy_1:       ;; Solo colisiona por un lado por la izquierda y no por la derecha -> Cambiar direccion
            ld a, e_ia_type(ix)
            cp #0
            jr z, no_muevo 
                ld e_vx(ix), #-1                ;; Pongo la velocidad a -1
                ld a,#1
                call sys_update_direccion_demonios
            no_muevo:
            ret
        no_colisiona_izq_enemy:             ;; Si no colisiona por la izquierda comprobar la esquina inferior derecha
        push iy
        pop hl
        inc hl                              ;; Compruebo el siguiente tile para la esquina inferior derecha
        xor a
        cp(hl)
        jr z, no_colisiona_der_enemy_2      ;; Colisiona por la derecha y no por la izquierda -> Cambio de direccion
        ld a, e_ia_type(ix)
        cp #0
        jr z, no_colisiona_der_enemy_2
            ld e_vx(ix), #1                 ;; Pongo la velocidad a 1
            ld a,#0
            call sys_update_direccion_demonios
            no_colisiona_der_enemy_2:       ;; NO colisiona por ningun lado

ret

;; ---------------------------------------------------------------------------------------------------------------------------
;; CALCULO INTERMEDIO
;; -> Calcula las colisiones con las plataformas tanto jugador como enemigos
;; ---------------------------------------------------------------------------------------------------------------------------
calculate_address_iy_intermedio:
    ld a,#(16-1) 
    ld d,a
    call calculate_address_iy

   ;; ************************************************************************************************************************
   ;; COMPROBACION DE SI SE TRATA DE UN ENEMIGO O NO
   ;; ************************************************************************************************************************

        ld a, e_type(ix)               ;; Compruebo si se trata del jugador
        and #e_type_input
        sub #e_type_input
        jr nz, no_player
            call collision_player      ;; Hago las comprobaciones necesario para el jugador 
            ;;call collision_obstaculos  ;; Compruebo los obstaculos               
            jr nada
        no_player:
        ld a, e_type(ix)               ;; Compruebo si se trata del jugador
        and #e_type_objeto
        sub #e_type_objeto
        jr nz, no_objeto
            jr nada
        no_objeto:
            call collision_enemy       ;; Hago las comprobaciones necesarias para el enemigo 
        nada:
ret


;; ---------------------------------------------------------------------------------------------------------------------------
;; CALCULO DE LA DIRECCION DEL TILE DONDE ESTA EN JUGADOR
;; -> PARAMETRO: hay que pasarle por el registro D el pixel para comprobar el tile
;; -> LA DEVUELVO EN EL REGISTRO IY
;; -> ADDRESS = BASE + Y*20 + X
;; -> 8 * TY = Y -> Calcular la posicion en tiles
;; -> 4 * TX = X
;; ----------------------------------------------------------------------------------------------------------------------------

calculate_address_iy:
    
   ;; *************************************************************************************************************************
   ;; PASO 1:
   ;;       4 * TX = X -> Calcular Entity.x / 4  
   ;; *************************************************************************************************************************

      ;; Cojo la x del jugador -> Tomo el valor de ix, le sumo 1, leo lo que hay en esa pos de memoria y lo cargo en a
      ld    a, e_x(ix)                 ;; A = Entity.x
      ;;sub #1                           ;; Ajuste colision izquierda para que no se quede donde no hay plataforma
      ;; Para dividir utilizo el desplazamiento logico de bits a la derecha
      srl   a                          ;; A = Entity.x /2
      srl   a                          ;; A = Entity.x /4
      ld    c, a                       ;; C = Entity.x /4 -> Guardo el calculo en c para poder utilizar el registro a
      ld    b, #0                      ;; Para poder sumarlo despues

   ; **************************************************************************************************************************
   ;; PASO 2: 
   ;;       8 * TY = Y -> Calcular Entity.y / 8  **** 
   ;; PASO 3: 
   ;;       Y*20 = Y*16 + Y*4 -> Para ello multiplico por 16, luego por 4 y luego los sumo 
   ;;       -> Como tengp que dividir por 8 y luego multiplicar por 16 
   ;;       No puedo multiplicar por dos directamente porque como estamos desplazando eliminamos el resto y no daría el mismo resultado
   ;; ************************************************************************************************************************
      ;; Colisiona por la derecha
      ld    a, e_y(ix)                 ;; A = Entity.y                     ;; 0b1000'0110
      add d                    
      ;; Elimino los tres ultimos bits y los pongo a 0
      ;; Equivale a 3 veces srl a (A = Entity.y /8 ) y 3 sll (A = 8*(Entity.y /8))
      and #0b11111000                  ;; A = 8*int(Entity.y /8)           ;; 0b1000'0000 -- 110
      
      ;; Calculo Y*4 -> Dividir el 8 entre 2 
      ld    e, a                       ;; /               
      srl   e                          ;; | DE = 4*int(Entity.y /8)
      ld    d, b                       ;; \

      ;; 0 < y < 160
      ;; Tengo que tener en cuenta si cuando multiplico voy a seguir en el rango de un byte o no
      ;; Sumar un numero a si mismo -> Si estoy en un valor superior a 128 necesitos mas bits

      ld    l, a                       ;;
      ld    h, d                       ;;  HL = A = 8*int(Entity.y /8) 
      add   hl, hl                     ;;  HL =    16*int(Entity.y /8)    ;; 0b0000'0000 -- 110
      add   hl, de                     ;;  HL =    20*int(Entity.y /8)
      
   ;; ************************************************************************************************************************
   ;; PASO 4: 
   ;;       HL = Y*20 + X -> Sumo la x calculada
   ;; ************************************************************************************************************************
      
      add   hl, bc                     ;;  HL =    20*int(Entity.y /8) + (Entity.x /4)
      ex    de, hl                     ;;  DE =    20*int(Entity.y /8) + (Entity.x /4)

   ;; ************************************************************************************************************************
   ;; PASO 5: 
   ;;       IY = BASE + Y*20 + X -> Sumo la base 
   ;; ************************************************************************************************************************
      push de
      call man_get_current_map         ;; Cojo el mapa que toca    
      ld__iy_de
      pop de
      ;; ld    iy, #_tilemap_01        ;; IY = BASE ADDRESS
      add   iy, de                     ;; IY = BASE + 20*int(Entity.y /8) + (Entity.x /4)

  
ret
