;; This file is part of The Angel's Choice.

;; The Angel's Choice is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

;; The Angel's Choice is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License along with Foobar. If not, see https://www.gnu.org/licenses/.

.module Generator

.include "man/datos_entity.inc"
.include "man/globals_ent.inc"
.include "funciones_cpct.inc"
.include "sys/globals_animation.inc"
.include "assets/assets.inc"

.globl fin_del_juego
.globl nivel
.globl prueba

.area _CODE
cont_enemigos:: ;;cuantos enemigos se han creado desde que comenzó el juego
    .db #0x30

eliminados::
    .db #0x20

.macro Comprobar_Tam _inicio, _tama_ent
    template_size = . - _inicio
    .ifne (template_size - _tama_ent)
        .error "Tamaño incorrecto"
    .endif
.endm

con_ia::
   .db #0x17, #70, #150, #0, #0, #0x03, #0x0c, #>_demonio_p_0, #<_demonio_p_0, #30, #110, #1, #0, #0, #>demo_estatico, #<demo_estatico, #1,#1,#0,#0,#-1,  #70, #150
      ;type, x, y, vx, vy, width, height, sprite_high, sprite_low, e_prev_x, e_prev_y, salto, der, izq,a nim_h, anim_l, debo_animar,direccion, xs, ys
Comprobar_Tam con_ia, tam_ent

x_posibles_nivel_3:
    .db #20, #65, #40, #20, #65, #40, #20, #65, #20, #40, #45, #70

y_posibles_nivel_3:
    .db #205, #205, #173, #141, #141, #109, #77, #77, #29, #45, #29, #45

x_posibles_nivel_2:
    .db #23, #30,#65, #15, #45, #10, #65, #50, #40, #10

y_posibles_nivel_2:
    .db #197,#197,#173, #165, #141, #125, #101, #69, #53, #69

x_posibles_nivel_1:
    .db #30,#50,#65, #15, #50, #10, #30, #70, #55, #40, #10

y_posibles_nivel_1: 
    .db #197,#197, #173, #165, #141, #125, #101, #101, #69, #53, #69

posiciones_tomadas::
    .ds #12

x_posibles::
    .dw x_posibles_nivel_1
y_posibles:
    .dw y_posibles_nivel_1

maximo: ;numero_de_plataformas
    .db 0


type: .db 0 ;variable que marca que enemigo sale

plataforma_actual:
    .db 0

sys_generate_init::

;;poner a 0 plataformas ya cogidas
    ld de,#posiciones_tomadas
    ld a,#0
    ld bc,#12
    call cpct_memset_asm


    ld a, #0x30
    ld (cont_enemigos),a
    ld a, #35   ;; CAMBIAR A CUALQUIER VALOR MENOR QUE 0X30, SERÁ EL VALOR DE ENEMIGOS QUE HAY QUE ELIMINAR PARA PASAR AL SIGUIENTE NIVEL
    ld (eliminados),a
    ld a, (nivel)
    cp #1
    jr nz, no_estoy_en_nivel_1
        ld hl, #x_posibles_nivel_1
        ld (x_posibles), hl
        ld hl, #y_posibles_nivel_1
        ld (y_posibles), hl
        ld a, #11
        ld (maximo), a
        ret
    no_estoy_en_nivel_1:
    cp #2
    jr nz, no_estoy_en_nivel_2
        ld hl, #x_posibles_nivel_2
        ld (x_posibles), hl
        ld hl, #y_posibles_nivel_2
        ld (y_posibles), hl
        ld a, #10
        ld (maximo), a
        ret
    no_estoy_en_nivel_2:
    cp #3
    jr nz, no_estoy_en_nivel_3
        ld hl, #x_posibles_nivel_3
        ld (x_posibles), hl
        ld hl, #y_posibles_nivel_3
        ld (y_posibles), hl
        ld a, #12
        ld (maximo), a
        ret
    no_estoy_en_nivel_3:
        cp #4
        jr nz, no_estoy_en_nivel_4
        ld hl, #x_posibles_nivel_1
        ld (x_posibles), hl
        ld hl, #y_posibles_nivel_1
        ld (y_posibles), hl
        ld a, #11
        ld (maximo), a
        ret
    no_estoy_en_nivel_4:
        ld hl, #x_posibles_nivel_2
        ld (x_posibles), hl
        ld hl, #y_posibles_nivel_2
        ld (y_posibles), hl
        ld a, #10
        ld (maximo), a
        ret

ret

man_generate_enemigo:
    push hl
    call man_create_entity
    ;(2B DE) to	Pointer to the destination (first byte where bytes will be written)
    ;(2B HL) from	Pointer to the source (first byte from which bytes will be read)
    ;(2B BC) size	Number of bytes to be set (>= 1)
    ld d,h
    ld e,l
    pop hl
    ld bc,#tam_ent
    push de
    call cpct_memcpy_asm
    pop ix

    ret

sys_generator_update::
    call man_free_space
    cp #0 ;si hay espacio libre
    jp z, no_mas
    ld a, (cont_enemigos)
    cp #0
    jp z, no_mas ; y todavía podemos seguir generando enemigos
        sub #1
        ld (cont_enemigos),a;restamos y generamos 1 nuevo
        ld hl, #con_ia
        call man_generate_enemigo
        call calcular_pos


        ld a, (nivel) 
        cp #1 ;si estoy en nivel 1 no hago nada mas
        ret z
        cp #2
        jr nz, no_genero_nivel_2 ;;EN EL NIVEL 2 GENERO CHETADOS

                ld a, #2
                ld e_cont_colisiones(ix),a
                ld e_ia_type(ix), #0
                ld e_width(ix), #0x03
                ld e_height(ix), #0x0c
                ld e_sprite_h(ix), #>_demonio_che_0
                ld e_sprite_l(ix), #<_demonio_che_0
                ld animacion_h(ix), #>demo_chetado
                ld animacion_l(ix), #<demo_chetado
                jp no_mas

        no_genero_nivel_2:
        cp #3
        jr nz, no_genero_nivel_3    ;;;EN EL NIVEL 3 GENERO QUE SE MUEVAN
            
                ld e_ia_type(ix), #1
                ld a, #-1
                ld e_vx(ix),a
                ld e_width(ix), #0x04
                ld e_height(ix), #0x0a
                ld e_sprite_h(ix), #>_demonis_0
                ld e_sprite_l(ix), #<_demonis_0
                ld animacion_h(ix), #>demo_izquierda
                ld animacion_l(ix), #<demo_izquierda
                jp no_mas

        no_genero_nivel_3:
        cp #4
        jr nz, no_genero_nivel_4    ;;;; EN EL NIVEL 4 GENERO ESTATICOS Y QUE SE MUEVAN
                ld a, (type)
                cp #0
                jp nz, type_1
                    ld a, #1
                    ld (type),a
                    jr no_mas
                type_1:
                    ld e_ia_type(ix), #1
                    ld a, #-1
                    ld e_vx(ix),a
                    ld e_width(ix), #0x04
                    ld e_height(ix), #0x0a
                    ld e_sprite_h(ix), #>_demonis_0
                    ld e_sprite_l(ix), #<_demonis_0
                    ld animacion_h(ix), #>demo_izquierda
                    ld animacion_l(ix), #<demo_izquierda
                    ld a, #0
                    ld (type),a
                    jr no_mas


        no_genero_nivel_4:   ;; EN EL NIVEL 5 CHETADOS Y QUE SE MUEVEN
                ld a, (type)
                cp #0 
                jp nz, otros_tipos
                    ld a, #2
                    ld e_cont_colisiones(ix),a
                    ld e_ia_type(ix), #0
                    ld e_width(ix), #0x03
                    ld e_height(ix), #0x0c
                    ld e_sprite_h(ix), #>_demonio_che_0
                    ld e_sprite_l(ix), #<_demonio_che_0
                    ld animacion_h(ix), #>demo_chetado
                    ld animacion_l(ix), #<demo_chetado
                    ld a, #1
                    ld (type),a
                jr no_mas

            otros_tipos:
                    ld e_ia_type(ix), #1
                    ld a, #-1
                    ld e_vx(ix),a
                    ld e_width(ix), #0x04
                    ld e_height(ix), #0x0a
                    ld e_sprite_h(ix), #>_demonis_0
                    ld e_sprite_l(ix), #<_demonis_0
                    ld animacion_h(ix), #>demo_izquierda
                    ld animacion_l(ix), #<demo_izquierda
                ld a, #0
                ld (type),a
    no_mas:
ret




sys_eliminados_update::
    ld a, (eliminados)
    cp #0
    ret nz
    ld a, (nivel)
    cp #5
    jr z, fin_juego
        ld a, #3
        ld (fin_del_juego),a
        ret
    fin_juego:
        ld a, #2
        ld (fin_del_juego),a

    ret
sys_restar_enemigo::
    ld a, (eliminados)
    sub #1
    ld (eliminados),a
ret

;; -----------------------------------------------------------------------------------------------------------------------------
;; CALCULAR POSICION
;; -> Cambia las posiciones x,y de la entidad del registro ix
;; -> bc = plataforma en la que aparece la entidad
;; -----------------------------------------------------------------------------------------------------------------------------

calcular_pos::
    
    call calcular_aleatorio
    ld b,#0 


    push ix 

    ld e_plat(ix),c
    ld hl, #posiciones_tomadas
    add hl,bc
    ld (hl), #1
    



    ld ix, #x_posibles
    ld h, 1(ix)
    ld l, 0(ix)
    push hl
    pop ix
    
                   ;; la primera posicion del array
    add ix,bc                       ;; sumo el numero de la plataforma que le he pasado por parametro
    ld a,(ix)                       ;; cargo en a la posicion
    pop ix
    ld e_x(ix), a                   ;; pongo la posicion de la entidad

    push ix                 
    ld ix, #y_posibles
    ld h, 1(ix)
    ld l, 0(ix)
    push hl
    pop ix
    add ix,bc
    ld a,(ix)
    pop ix
    ld e_y(ix), a
    
   ; ld e_plataforma(ix),c            ;; guardo la plataforma
  
ret


;; -----------------------------------------------------------------------------------------------------------------------------
;; CALCULAR ALEATORIO
;; -> Calcula un numero aleatorio entre 0 y 12 para saber en que plataforma se va a colocar el enemigo
;; -> Devuelve el numero aleatorio en C
;; -----------------------------------------------------------------------------------------------------------------------------

calcular_aleatorio:
    ;;ld a,#2
    ld a,(prueba)
    call cpct_setSeed_xsp40_u8_asm   ;; para cambiar la semilla del aleatorio     
    call cpct_getRandom_xsp40_u8_asm
    ld hl, #maximo
   ld c,   (hl)                    ;; numero maximo (12)
   primer_random:                    ;; condicion para sacar un numero entre 0-12
      cp c
      jr nc, if_random_overflow         
      ;; IF @( RANDOM < 12 )
      ;; {
         ld c,a                      ;; cargo en numero en el registro c
         jr endif_random_overflow
      ;; }
   if_random_overflow:
      ;; ELSE IF @( RANDOM >= 12 )
      ;; {
        ld hl, #maximo
        ld b, (hl)
         sub b
         jr primer_random            ;; vuelvo a calcular el aleatorio  
      ;; }
   endif_random_overflow:
    ld (plataforma_actual),a
    
    ld hl, #posiciones_tomadas
    ld a, (plataforma_actual)
    ld e, a
    ld d, #0
    add hl,de
    ld a,(hl)
    cp #1
    jr nz, salgo
        ld a,(prueba)
        add #1
        ld (prueba),a
        jp calcular_aleatorio
    salgo:
    
ret


