;; This file is part of The Angel's Choice.

;; The Angel's Choice is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

;; The Angel's Choice is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License along with Foobar. If not, see https://www.gnu.org/licenses/.

.module HUD

.include "cpctelera.h.s"
.include "man/datos_entity.inc"
.include "man/globals_ent.inc"
.include "man/globals_maps.inc"
.include "sys/datos_hud.inc"
.include "assets/assets.inc"
.include "funciones_cpct.inc"
.include "sys/globals_render.inc"
.include "sys/globals_generator.inc"
.area _CODE

.globl fin_del_juego
.globl _back_buffer
.globl nivel

.globl prueba

tam_coras = 6
h_cant_coras:
    .db #3
corazones:
corazon_1:
    .db #3, #172, #0x06, #16, #>_carta, #<_carta
    ;e_x,_ey,e_width,e_height,sprite_h,sprite_l,cant
corazon_2:
    .db #10, #172, #0x06, #16, #>_corazon_v, #<_corazon_v
corazon_3:
    .db #17, #172, #0x06, #16, #>_corazon_v, #<_corazon_v

detalles_puntuacion::
    .db #64, #176, #1, #1, #0
detalles_level::
    .db #30, #176, #1, #1, #0
enemigos_eliminados::
    .db #0x30, #0 ;marca los enemigos eliminados sin tener en cuenta los cambios entre cielo e infierno
puntuacion::
    .db #0x30, #0x30, #0x30, #0 ;ahora mismo en el marcador hay 0 0 (cada 30) y el cero final marca el final del string

cont_corass: ;  contador de vidas en el nivel para dibujar
    .db #3
coras_cielo:: ; vidas que se tenían en el cielo antes de cambiar al infierno
    .db #3
is_showing_cora: ;muestra y esconde al entrar en cielo e infierno
    .db 1
toca_dibujar:;marca cuando hay que dibujar una vida (cada 10)
    .db 1

x_posibles_puerta:
    .db #10
y_posibles_puerta:
    .db #10

enemies: .db 'L', 'E', 'V', 'E', 'L',0
;score: .db 'S','C','O','R','E',0
sys_init_hud::
    ld a, (nivel)
    add #0x30
    ld (enemigos_eliminados), a
    ld ix, #corazon_1
    ld h_sprite_h(ix),#>_carta
    ld h_sprite_l(ix),#<_carta
    ld ix, #corazon_2
    ld h_sprite_h(ix),#>_carta
    ld h_sprite_l(ix),#<_carta
    ld ix, #corazon_3
    ld h_sprite_h(ix),#>_carta
    ld h_sprite_l(ix),#<_carta
    ld a,#3
    ld (coras_cielo),a
    ld a,#3
    ld (h_cant_coras),a
    ld ix, #puntuacion
    ld h_x(ix), #0x30
    ld h_y(ix), #0x30
    ld ix, #detalles_puntuacion
    ld h_inc(ix), #1
    ld h_fondo(ix), #0
    ld h_color(ix), #1
    ld ix, #detalles_level
    ld h_fondo(ix), #0
    ld h_color(ix), #1
ret

sys_hide_corazon: ;muestra el corazon al entrar en el cielo
    ld a, #0            ;guardamos que mostramos
    ld (is_showing_cora),a
    ld a, #2   ;buscamos el entity carta
    call man_get_from_idx
    ld e_type(ix), #0x66 ;hago que sea renderizable
ret

sys_show_corazon: ;muestra el corazon al entrar en el cielo
    ld a,(toca_dibujar)
    cp #0
    jr z, salgo_sin_dibujar
    ld a, #1            ;guardamos que mostramos
    ld (is_showing_cora),a
    ld a, #2   ;buscamos el entity carta
    call man_get_from_idx
    ld e_type(ix), #0x67 ;hago que sea renderizable
    salgo_sin_dibujar:
ret
sys_show_vida_extra: ;te regala una vida
    ld a, (toca_dibujar)
    cp #0
    jr nz, ya_muestro_uno
    
    ld a,#1
    ld (toca_dibujar),a
    ld a, #2   ;buscamos el entity carta
    call man_get_from_idx
    cpctm_push af, bc, de, hl
    call calcular_pos
    cpctm_pop hl, de, bc, af
    ld a, e_y(ix)
    sub #2
    ld e_y(ix),a
    
    ld hl, #cambio
    inc hl
    ld a, (hl)
    cp #1
    jr nz, ya_muestro_uno
    ld a, #1            ;guardamos que mostramos
    ld (is_showing_cora),a
    ld e_type(ix), #0x67 ;hago que sea renderizable
    
    
    ya_muestro_uno:
    ret
sys_add_corazon::
    ld hl, #cambio
    inc hl
    ld a, (hl)
    cp #1
    jr nz, no_tengo_que_anyadir
        ld a, (h_cant_coras)
        cp #3
        jr z, no_tengo_que_anyadir
            add #1
            ld (h_cant_coras),a
            ld hl, #corazones
            ld b, #0
            ld c,#tam_coras
            sub #1
            cp #0
            jr nz, avanzo
                jp add_cora
            avanzo: ;(tam_coras*(h_cant_coras))
            add hl,bc
            sub #1
            cp #0
            jr nz, avanzo
            add_cora:
            push hl
            pop ix
            ld h_sprite_h(ix),#>_carta
            ld h_sprite_l(ix),#<_carta
            ld a,#0
            ld (is_showing_cora),a
            ld (toca_dibujar),a
    no_tengo_que_anyadir:
ret

sys_update_corazones::
    ;; reproducir efecto
    ld a, #1             ;; A = No Channel (0,1,2)
    ld l, #1             ;; L = Instrument Number (>0) 
    ld h, #0x0F          ;; H = Volume (0...F)
    ld e, #40            ;; E = Note (0...143)
    ld d, #0             ;; D = Speed (0 = As original, 1...255 = new Speed (1 is the fastest))
    ld bc, #0            ;; BC = Inverted Pitch (-#FFFF -> FFFF). 0 is no pitch. The higher the pitch, the lower the sound.
    call cpct_akp_SFXPlay_asm

     cpctm_setBorder_asm HW_MAUVE
    ld a, (h_cant_coras)
    sub #1
    cp #-1
    jr z, no_bajo_mas
        ld (h_cant_coras),a
        ld hl, #corazones
        ld b, #0
        ld c,#tam_coras
        sub #1
        cp #-1
        jr nz, multiplicacion
            jp change_color
        multiplicacion: ;(tam_coras*(h_cant_coras))
        add hl,bc
        sub #1
        cp #-1
        jr nz, multiplicacion
        change_color:
        push hl
        pop ix
        call draw_fondo_both
        ld h_sprite_h(ix),#>_corazon_v
        ld h_sprite_l(ix),#<_corazon_v

    ret
    no_bajo_mas:
        ld a, #1
        ld (fin_del_juego),a
        ret

sys_update_puntuacion::
    ;; reproducir efecto
    ld a, #1             ;; A = No Channel (0,1,2)
    ld l, #1             ;; L = Instrument Number (>0) 
    ld h, #0x0F          ;; H = Volume (0...F)
    ld e, #90            ;; E = Note (0...143)
    ld d, #0             ;; D = Speed (0 = As original, 1...255 = new Speed (1 is the fastest))
    ld bc, #0            ;; BC = Inverted Pitch (-#FFFF -> FFFF). 0 is no pitch. The higher the pitch, the lower the sound.
    call cpct_akp_SFXPlay_asm

    ld ix, #detalles_puntuacion
    ld a, h_inc(ix)
    ld b, a
    ld ix, #puntuacion
    call sys_update_puntos
    ret

;recibe en ix la variable a cambiar (puntuacion o enemigos eliminados) y en b el incremento

sys_update_puntos:
    ld a, h_y(ix) 
    add b
    cp #0x3A ;si se pasa de 9 en ascii, cambia decena
    jr nc, cambio_decena

        push af             ;; Guardo en "C" el registro "A" para devolverlo mas adelante *
        ld c, #1;call calcular_aleatorio_uno
        pop af
        push af
        and #0b00001111     ;; Del numero actual de puntos, me quedo con el ultimo digito en el registro "A"
        cp c           ;; Si ese digito == '5', entonces realizar accion
        jr nz, salir_fuera
            ;; 15      -> 0001 0101 AND 0000 1111  ->  0000 0101
            
            push ix
            call sys_show_vida_extra
            pop ix
           
        salir_fuera:
        pop af

        ld h_y(ix),a
        ret
    cambio_decena:
        cp #0x3A ;;si es 10, se vuelve x 0
        jr z, es_10
         ;sino es x 1
            ld a, #0x31
            ld h_y(ix),a
            jr avanzo_decena
        es_10:
            ld a, #0x30 
            ld h_y(ix),a
        avanzo_decena:
        
       ld a, h_x(ix)
       add #1
       cp #0x3A ;si se pasa de 9 en ascii, no aumenta
        ret z
       ld h_x(ix),a 
ret

sys_hud_change_to_hell::
    call sys_hide_corazon
    ld ix, #corazon_2
    ld h_sprite_h(ix),#>_corazon_v
    ld h_sprite_l(ix),#<_corazon_v
    ld ix, #corazon_3
    ld h_sprite_h(ix),#>_corazon_v
    ld h_sprite_l(ix),#<_corazon_v
    ld a, (h_cant_coras) ;recojo la cantidad de vidas en ese momento en el cielo y lo guardo
    ld (coras_cielo), a
    ld a, #1
    ld (h_cant_coras),a
    ld ix, #detalles_puntuacion
    ld h_inc(ix), #2
    ld h_fondo(ix), #3
    ld h_color(ix), #0x0f
    ld ix, #detalles_level
    ld h_fondo(ix), #3
    ld h_color(ix), #0x0f
ret

sys_hud_change_to_heaven::
    call sys_show_corazon
    ld a, (coras_cielo)
    ld (h_cant_coras),a
    ld hl, #corazones
    ld b, #0
    ld c,#tam_coras
    sub #1
    cp #-1
    jr nz, multiplicacion_2
        jp change_color_2
    multiplicacion_2: ;(tam_coras*(h_cant_coras))
    push hl
    pop ix
    ld h_sprite_h(ix),#>_carta
    ld h_sprite_l(ix),#<_carta
    push ix
    pop hl
    add hl,bc
    sub #1
    cp #-1
    jr nz, multiplicacion_2
        jp fin
    change_color_2:
    push hl
    pop ix
    ld h_sprite_h(ix),#>_corazon_v
    ld h_sprite_l(ix),#<_corazon_v
    fin:
    ld ix, #detalles_puntuacion
    ld h_inc(ix), #1
    ld h_fondo(ix), #0
    ld h_color(ix), #1
    ld ix, #detalles_level
    ld h_fondo(ix), #0
    ld h_color(ix), #1
ret

render_hud::
    ld ix, #corazon_1
    call render_corazon
    ld ix, #corazon_2
    call render_corazon
    ld ix, #corazon_3
    call render_corazon
nos_vamos:
    ld ix, #detalles_puntuacion 
    ld iy, #puntuacion
    ld c, #0
    ld b, #0
    call render_frase ;le pasamos en iy lo que tiene que escribir
    ld ix, #detalles_level
    ld iy, #enemies
    ld c, #0
    ld b, #0
    call render_frase ;le pasamos en iy lo que tiene que escribir
    ld ix, #detalles_level 
    ld iy, #enemigos_eliminados
    ld c, #0x16
    ld b, #0
    call render_frase


    
ret

render_corazon:
    ; Calculate a video-memory location for printing a string
   ld   de, (#_back_buffer)    ;; DE = Pointer to start of the screen
   ld    b, h_y(ix)                  ;; B = y coordinate (24 = 0x18)
   ld    c, h_x(ix)                  ;; C = x coordinate (16 = 0x10)

   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

    ex de,hl

   
    ld h, h_sprite_h(ix)
    ld l, h_sprite_l(ix)
   ld c,h_width(ix)
   ld b,h_height(ix)
   call cpct_drawSpriteMasked_asm
ret


draw_fondo_both:
    ld a, (cambio + 1)
    cp #1
    jr z, estamos_en_el_cielo
        ld a, #0xcc
        jr continua
        estamos_en_el_cielo:
            ld a, #0
        continua:
    ld de, #0xc000
    push af
    call draw_fondo
    pop af
    ld de, #0x8000
    call draw_fondo
    ret

;viene de como parametro con ambas memorias de video y a con el color del fondo
draw_fondo:
    push af
    ;; C000 ES DONDE EMPIEZA LA PANTALLA
     ; Calculate a video-memory location for printing a string
     ;; DE = Pointer to start of the screen
   ld    b, h_y(ix)                  ;; B = y coordinate (24 = 0x18)
   ld    c, h_x(ix)                  ;; C = x coordinate (16 = 0x10)

   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL
   ;(2B DE) memory	Video memory pointer to the upper left box corner byte
   ;(1B A ) colour_pattern	1-byte colour pattern (in screen pixel format) to fill the box with
   ;(1B C ) width	Box width in bytes [1-64] (Beware!  not in pixels!)
   ;(1B B ) height	Box height in bytes (>0)
  ex de,hl
   ld c,h_width(ix)
   ld b,h_height(ix)
   pop af
   call cpct_drawSolidBox_asm
ret

;en bc se pasa lo que se quiera mover el texto
render_frase::
    push bc
    ;; Set up draw char colours before calling draw string
   ld    h, h_fondo(ix)         ;; D = Background PEN (0)
   ld    l, h_color(ix)         ;; E = Foreground PEN (3)

   call cpct_setDrawCharM0_asm   ;; Set draw char colours
    pop bc
   ;; Calculate a video-memory location for printing a string
   ld   de, (#_back_buffer)    ;; DE = Pointer to start of the screen
   ld   a, h_x(ix) 
   add c
   ld   c, a            ;; B = y coordinate (24 = 0x18)
   ld a, h_y(ix)
   add b
   ld    b,  a           ;; C = x coordinate (16 = 0x10)

   call cpct_getScreenPtr_asm    ;; Calculate video memory location and return it in HL

   ;; Print the string in video memory
   ;; HL already points to video memory, as it is the return
   ;; value from cpct_getScreenPtr_asm
   ;ld   iy, #string    ;; IY = Pointer to the string 

   call cpct_drawStringM0_asm  ;; Draw the string
ret







