;; This file is part of The Angel's Choice.

;; The Angel's Choice is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

;; The Angel's Choice is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License along with Foobar. If not, see https://www.gnu.org/licenses/.

.module Physics


.include "cpctelera.h.s"
.include "man/datos_entity.inc"
.include "man/globals_ent.inc"
.include "sys/globals_animation.inc"
.include "sys/globals_hud.inc"
.include "funciones_cpct.inc"


.area _CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;FUNCIONES PUBLICAS;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;

sys_physics_update::
    ld hl,#sys_physics_update_one 
    ld a,#e_type_physics
    call man_entity_for_all_matching

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;ACTUALIZA LOS VALORES DE POSICION DE LA ENTIDAD COMPROBANDO EL TECLADO;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sys_physics_update_input:
    call cpct_isAnyKeyPressed_asm
    or a
    jr z, fin_loop ;si no hay ninguna letra pulsada salta a comprobar el estado de las varaibles salto,x e y
        call movement_by_letras
        ;si entra aquí es que hay alguna letra pulsada y tiene que cambiar su estado
                
    fin_loop:
        ; si salto(ix) vale 1 es que estamos saltando por lo que entro al metodo de saltar
        ld a, salto(ix)
        cp #0
        jr z, nosalto
            ld debo_animar(ix),#1
            ld a,#1
            call sys_update_direccion_anim
            call move_y_arriba
        nosalto:
        ;si la izquierda vale 1 es que nos movemos hacia la izquierda y entramos al metodo de ir a la izquierda
        ld a, izq(ix)
            cp #0
            jr z, noizquierda
               ld debo_animar(ix),#1
               ld a,#3
               call sys_update_direccion_anim
                call move_x_izq
                ret
            noizquierda:
            ;si la derecha vale 1 es que nos movemos a la derecha y entramos en el metodo de mover a derecha
            ld a, der(ix)
            cp #0
            jr z, last
               ld debo_animar(ix),#1
               ld a,#2
               call sys_update_direccion_anim
                call move_x_de
                ret
            last: ;;si no se pulsa ninguna (salto, derecha e izquierda estan a 0), se anima en esperando
            ld a, der(ix)
            cp #1
            jr z, outfuncion
            ld a, izq(ix)
            cp #1
            jr z, outfuncion
            ld a, salto(ix)
            cp #1
            jr z, outfuncion
            ld debo_animar(ix),#1
            ld a,#0
            call sys_update_direccion_anim
outfuncion:
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;ACTUALIZA LAS POSICIONES X E Y PARA TODAS LAS ENTIDADES (MODULO PRINCIPAL);;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

sys_physics_update_one::
   ld a, e_type(ix)
   and #e_type_input
   jr z,no_input
      call sys_physics_update_input
      jp final
   no_input:
   ;ld a, e_type(ix)
   ;and #e_type_ia
   ;jr z, final 
      ld a, e_x(ix)
      ld e_prev_x(ix),a ;;;guardamos e_x en prev_x
      add e_vx(ix)
      ld e_x(ix),a
      ld a, e_y(ix)
      ld e_prev_y(ix),a ;;;guardamos e_y en prev_y
      add e_vy(ix)
      ld e_y(ix),a
final:
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;ACTUALIZA LOS VALORES DE POS ANTERIOR CON LOS VALORES ACTUALES;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


act_prev:;actualiza las posiciones anteriores en cada iteración del juego
   ld a, e_x(ix)
   ;;;guardamos e_x en prev_x
   ld e_prev_x(ix),a

   ld a, e_y(ix)
   ;;;guardamos e_y en prev_y
   ld e_prev_y(ix),a
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;FUNCIONES PRIVADAS;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;ACTUALIZA LOS VALORES DE ESTADO DE LA ENTIDAD COMPROBANDO EL TECLADO;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

movement_by_letras: ;dependiendo de las letras que pulse se activa un estado u otro
   call act_prev ;guardamos las posiciones antes de hacer cualquier cambio
   ld hl, #Key_Space ; si pulsamos W saltamos
   call cpct_isKeyPressed_asm
   jr z, no_pressed_Space
   ;arriba

      call salto_ahora
   no_pressed_Space:
      ld hl, #Key_CursorRight ;si pulsamos D vamos a la derecha
      call cpct_isKeyPressed_asm
      jr z,no_pressed_Right
         ;derecha
         call hay_mov_der;move_x_de
         ret

      no_pressed_Right:
         ld hl, #Key_CursorLeft ;si pulsamos A vamos a la izquierda
         call cpct_isKeyPressed_asm
         jr z,no_pressed_Left
            ; izquierda
            call hay_mov_izq ;move_x_izq
            ret
            no_pressed_Left:
               ld hl, #Key_P ;si pulsamos D vamos a la derecha
               call cpct_isKeyPressed_asm
               jr z,no_pressed_P
                  ;derecha
                  call hay_mov_der;move_x_de
                  ret

               no_pressed_P:
                  ld hl, #Key_O ;si pulsamos D vamos a la derecha
                  call cpct_isKeyPressed_asm
                  jr z,no_pressed_O
                  ;izquierda
                  call hay_mov_izq ;move_x_izq
                  ret

               no_pressed_O:
                  ld hl, #Key_CursorUp ;si pulsamos D vamos a la derecha
                  call cpct_isKeyPressed_asm
                  jr z,no_pressed_Up
                  ;saltar
                  call salto_ahora
                  ret
                  no_pressed_Up:
                     ld hl, #Joy0_Right ;si pulsamos D vamos a la derecha
                     call cpct_isKeyPressed_asm
                     jr z,no_pressed_JoyR
                        ;derecha
                        call hay_mov_der;move_x_de
                        ret

                     no_pressed_JoyR:
                        ld hl, #Joy0_Left;si pulsamos D vamos a la derecha
                        call cpct_isKeyPressed_asm
                        jr z,no_pressed_JoyL
                        ;izquierda
                        call hay_mov_izq ;move_x_izq
                        ret

                     no_pressed_JoyL:
                        ld hl, #Joy0_Up ;si pulsamos D vamos a la derecha
                        call cpct_isKeyPressed_asm
                        jr z,no_pressed_JoyU
                        ;saltar
                        call salto_ahora
                        ret
                        no_pressed_JoyU:


ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;ACTUALIZA EL VALOR DE ESTADO DE LA ENTIDAD HACIA LA DERECHA;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

hay_mov_der:
   ld der(ix),#1
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;ACTUALIZA EL VALOR DE ESTADO DE LA ENTIDAD HACIA LA IZQUIERDA;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

hay_mov_izq:
   ld izq(ix),#1
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;ACTUALIZA EL VALOR DE ESTADO DE LA ENTIDAD EN SALTO;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

salto_ahora::
   ld salto(ix),#1
   ld a,e_pos_salto(ix) ;ya estoy saltando?
   cp #0
   jr z, inicio_salto
      ret
   inicio_salto:;si comienzo el salto, guardo en la e_prev_salto, la y para la condicion
      ld a, #1
      ld e_pos_salto(ix),a
      ld a, e_y(ix)
      ld e_prev_salto(ix), a
   ;ld a,(cont_saltos)
   ;add #1
   ;ld (cont_saltos),a
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;HACEMOS LOS CAMBIOS PARA SEGUIR LA PARABOLA DEL SALTO;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

move_y_arriba::
   ;aumentamos la velocidad conforme avanza (si sube la velocidad es negativa por lo que se acerca a 0)
   ld a, e_vy(ix)
   cp #8
   jr z, no_mas_increment 
   inc e_vy(ix)
   no_mas_increment:
   ;cargamos y
   ld a, e_y(ix)
   ;;;guardamos en prev_y
   ld e_prev_y(ix),a
   add e_vy(ix) ;le añadimos la velocidad
   ld e_y(ix),a
   sub e_prev_salto(ix) ;esta es la posicion y en la que está cuando no salta, cuando tengamos mapa la condicion cambiara
   ret c ;si no hay carry ya ha subido y bajado
   ld e_vy(ix),#-10 ;ponemos otra vez la velocidad a la original
   ld a, e_prev_salto(ix)
   ld e_y(ix), a; la posicion a 120 por si hubiera bajado por debajo de este numero (121, 125...)
   ld salto(ix),#0 ;desactivamos salto
   ld e_pos_salto(ix),#0
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;MOVEMOS HACIA LA IZQUIERDA;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

move_x_izq:
   ld a, e_x(ix) ;cargamos la x
   sub e_vx(ix) ; restamos la velocidad (nos movemos hacia el 0)
   cp #1 ;; borde izq
   jr nc, no_carry_I ;; esta dentro de la linea = no carry
      ld a, e_x(ix)
      ;;;guardamos en prev_x
      ld e_prev_x(ix),a
      ld izq(ix),#0
      ret ;; se queda quieta porque ha llegado al max=69    
   no_carry_I:
      ld a, e_x(ix)
      ;;;guardamos en prev_x
      ld e_prev_x(ix),a
      sub e_vx(ix)
      ld e_x(ix), a
      ld izq(ix),#0
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;MOVEMOS A LA DERECHA;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

move_x_de:
   ld a, e_x(ix)
   add e_vx(ix)
   cp #76 ;; resta a- (80(lo que mide una linea) - ancho_sprite = 17)
   jr nc, no_carry ;; esta dentro de la linea = carry
      ld a, e_x(ix)
      ;;;guardamos en prev_x
      ld e_prev_x(ix),a
      add e_vx(ix)
      ld e_x(ix), a
      ld der(ix),#0
      ret
   no_carry:
    ;;se queda quieta porque ha llegado al max=74
    ld a, e_x(ix)
      ;;;guardamos en prev_x
      ld e_prev_x(ix),a
        ld der(ix),#0
ret